package appLayer.transactionRelated;

import java.math.BigDecimal;
import java.util.HashMap;

import javax.persistence.Entity;
import javax.persistence.Transient;


import appLayer.AccountNotFoundException;
import appLayer.CashFlow;
import appLayer.account;
import appLayer.accountException;
import appLayer.client;
import appLayer.configs;
import appLayer.entry;
import appLayer.item;

@Entity
public class invoice extends appTransaction {
	@Transient
	account pendingCreditAccount = null;
	@Transient
	account pendingDebitAccount = null;
	@Transient
	account finishCreditAccount = null;
	@Transient
	account finishDebitAccount = null;

	
	public invoice() {
		super();
		
	}

	
	public invoice(transactions parent) {
		super(parent);
	}
	
	private void prepareEntryCreation() {
		try {
			pendingDebitAccount = client.getAccounts().getReceivablesAccount();
			pendingCreditAccount = client.getAccounts().getRevenuesAccount();

			finishDebitAccount = client.getAccounts().getBankAccount();
			finishCreditAccount = client.getAccounts().getReceivablesAccount();
		} catch (AccountNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static int getType() {
		// due to GUILayer/newTransactionSelectTransactionDetails this code must
		// be
		// the index defined in
		// applayer/transactionRelatzed/transactions.java:init()+1
		return 1;
	}

	@Override
	public String getTransactionName() {
		return "invoice"; //$NON-NLS-1$
	}

	@Override
	public int getNumWorkflowSteps() {
		// TODO Auto-generated method stub
		return 2;
	}

	public HashMap<Integer, String> getTodoItems() {
		HashMap<Integer, String> result = new HashMap<Integer, String>();
		for (appTransaction currentTransaction : client.getTransactions()
				.getTransactions()) {

			if ((currentTransaction.getTypeID() == getType())
					&& (currentTransaction.getWorkflowStep() == 2)) {
				result.put(currentTransaction.getID(),
						currentTransaction.getNumber()); //$NON-NLS-1$ //$NON-NLS-2$

			}
		}
		return result;
	}

	@Override
	public CashFlow getCashFlow() {
		return CashFlow.RECEIVING;
	}

	@Override
	public boolean isVATRequiredInStep(int step) {

		return step == 1;
	}

	@Override
	public void createEntriesForWorkflowStep(int step) {
		account creditAccount = null;
		account debitAccount = null;
		prepareEntryCreation();
		if (workflowStep == 1) {


			creditAccount = pendingCreditAccount;

			try {
				creditAccount.setReferTo(getContact().getID());
			} catch (accountException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			HashMap<account, BigDecimal> valuesToBook = new HashMap<account, BigDecimal>();
			if (isVATRequiredInStep(workflowStep)) {
				// add total of all items and add their respective vat values to
				// the hashmap valuesToBook
				for (item currentItem : getItems()) {
					BigDecimal currentVal;

					// find out which net value to book on which account
					currentVal = valuesToBook.get(pendingDebitAccount);
					if (currentVal == null) {
						currentVal = new BigDecimal(0);
					}
					currentVal = currentVal.add(currentItem.getTotal());
					if (currentVal.compareTo(new BigDecimal(0)) > 0) {
						valuesToBook.put(pendingDebitAccount, currentVal);
					}
					account vatAccount;
					try {
						vatAccount = client.getAccounts()
								.getTurnoverTaxAccount();
						if (!configs.isTaxmodeIssue()) {
							vatAccount= client.getAccounts().getUndueVatAccount();
						}
						currentVal = valuesToBook.get(vatAccount);
						if (currentVal == null) {
							currentVal = new BigDecimal(0);
						}
						currentVal = currentVal.add(currentItem.getTotalGross()
								.subtract(currentItem.getTotal())); // get the
						// amount of VAT
						// spend
						if (currentVal.compareTo(new BigDecimal(0)) > 0) {
							valuesToBook.put(vatAccount, currentVal);
						}
					} catch (AccountNotFoundException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}// questionable
						// now do the same with the VAT amount

				}
			}
			

			int entryIndex = 0;
			setGrossValue(getTotalGross());
			for (account currentAccount : valuesToBook.keySet()) {
				BigDecimal toBook = valuesToBook.get(currentAccount);
				try {
					if ((currentAccount.getID() == client.getAccounts()
							.getTurnoverTaxAccount().getID())
							|| (currentAccount.getID() == client.getAccounts()
									.getUndueVatAccount().getID())) {
						// if we're booking against a VAT account which can be
						// 1776 in SKR03/tax on issue=Sollbesteuerung or 1766 in
						// SKR03/tax on payment=Istbesteuerung or their SKR04
						// pendants
						creditAccount = currentAccount;
						try {
							debitAccount = client.getAccounts()
									.getReceivablesAccount();
						} catch (AccountNotFoundException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					} else {
						// not booking against VAT
						creditAccount = pendingCreditAccount;
						debitAccount = pendingDebitAccount;
					}
				} catch (AccountNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				// create entry WITHOUT the number here, otherwise the document
				// with the number is assumed to be consumed
				entry entryToBook = new entry(
						getIssueDate(),
						getTypeName() + " " + getNumber(), toBook, creditAccount, debitAccount, "", ""); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				entryToBook.setReferredTransaction(this);
				entryToBook.setContact(getRecipient());
				setDefaultCreditAccount(creditAccount);
				setDefaultDebitAccount(debitAccount);
				
				entryToBook.setReference(getNumber());
				// advance only once, not for every value
				if (entryIndex == valuesToBook.size() - 1) {
					entryToBook.setAdvancesTransactionWorkflow(true);
				}
				entries.add(entryToBook);
				entryIndex++;

			}
		} else if (workflowStep == 2) {
			// 2nd Workflow step: balancing the payment
			entry balanceEntry = new entry(
					getIssueDate(),
					getTypeName() + " " + getNumber(), getTotalGross(), finishCreditAccount, finishDebitAccount, "", ""); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			balanceEntry.setReferredTransaction(this);
			balanceEntry.setReference(getNumber());

			balanceEntry.setAdvancesTransactionWorkflow(true);
			entries.add(balanceEntry);
			if (!configs.isTaxmodeIssue()) { //$NON-NLS-1$
				// tax on payment = istbesteuerung

				/**
				 * In this case (tax on payment = istbesteuerung) we need to
				 * balance a second entry to mark the VAT due, i.e. balance 1766
				 * Ust nicht fällig against 1776 USt 19%
				 * */
				entry taxDueEntry = new entry(
						getIssueDate(),
						getTypeName() + " " + getNumber(), getTotalGross().subtract(getTotal()), creditAccount, debitAccount, "", ""); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				taxDueEntry.setReferredTransaction(this);
				taxDueEntry.setReference(getNumber());

				try {
					taxDueEntry.setCreditAccount(client.getAccounts()
							.getUndueVatAccount()); //$NON-NLS-1$
					taxDueEntry.setDebitAccount(client.getAccounts()
							.getTurnoverTaxAccount()); //$NON-NLS-1$
				} catch (AccountNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				taxDueEntry.setAdvancesTransactionWorkflow(true);
				entries.add(taxDueEntry);

			}

		}

	}

}
